package code;

public class Literal extends Address {
	private String literal;
	
	public Literal( String literal ) {
		this.literal = literal;
		}
	
	public Literal( long literal ) {
		if ( literal == 0 )
			this.literal = "0x0";
		else if ( literal < 0 )
			this.literal = "-0x" + Long.toHexString( - literal );
		else
			this.literal = "0x" + Long.toHexString( literal );
		}

	public String toString() {
		return literal;
		}
	
	}
