package node.exprNode.binaryNode.boolNode;
import node.*;
import node.exprNode.*;
import node.exprNode.binaryNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public abstract class BoolNode extends BinaryNode {

	public BoolNode( ExprNode left, ExprNode right ) {
		super( left, right );
		}

	public Type checkType() {
		Type leftType = left.checkType();
		Type rightType = right.checkType();
		operandType = BoolType.type;
		type = BoolType.type;
		left = left.castTo( Type.CAST_IMPLICIT, type );
		right = right.castTo( Type.CAST_IMPLICIT, type );
		return type;
		}

	}
