package runEnv.basicValue;

import runEnv.*;

public class BoolValue extends BasicValue {

	public final static BoolValue defaultValue = new BoolValue( false );

	private boolean value;

	public BoolValue( boolean value ) {
		this.value = value;
		}

	public boolean boolValue() {
		return value;
		}

	public String toString() {
		return "" + value;
		}

	public String stringValue() {
		return "" + value;
		}

	public boolean equals( RunValue otherValue ) {
		return otherValue.boolValue() == value;
		}
	}
