package runEnv.basicValue;

import runEnv.*;

public class VoidValue extends BasicValue {

	public final static VoidValue defaultValue = new VoidValue();

	public final static VoidValue value = defaultValue;

	public VoidValue() {
		}

	public String toString() {
		return "void";
		}

	public boolean equals( RunValue otherValue ) {
		return otherValue instanceof VoidValue;
		}
	}
