package text;

import java.io.*;

public class Print {

	public static boolean DEBUG = false;

	private static FormattedOutput error;
	private static FormattedOutput reprint;
	private static PlainOutput interp;
	private static FormattedOutput compile;

	public static FormattedOutput error() { return error; }
	public static FormattedOutput reprint() { return reprint; }
	public static PlainOutput interp() { return interp; }
	public static FormattedOutput compile() { return compile; }

	public static void setError( File file ) { 
		Print.error = new FormattedOutput( file ); 
		}
	public static void setReprint( File file ) { 
		Print.reprint = new FormattedOutput( file ); 
		}
	public static void setInterp( File file ) { 
		Print.interp = new PlainOutput( file ); 
		}
	public static void setCompile( File file ) { 
		Print.compile = new FormattedOutput( file ); 
		}

	}
