package type.basicType;

import type.*;
import runEnv.*;
import runEnv.basicValue.*;

public  class BoolType extends BasicType {

	public final static BoolType type = new BoolType();

	public BoolType() {
		}
	
	public boolean equals( Type type ) {
		return type instanceof BoolType;
		}

	public String toString() {
		return "bool";
		}
		
	public void initAddress( RunEnv runEnv, PtrValue address ) {
		address.setValue( BoolValue.defaultValue );
		}
	}
