package type.basicType;

import type.*;
import runEnv.*;
import runEnv.basicValue.*;

public  class FloatType extends BasicType {

	public final static FloatType type = new FloatType();

	public FloatType() {
		}

	public boolean equals( Type type ) {
		return type instanceof FloatType;
		}

	public String toString() {
		return "float";
		}
		
	public boolean isCastable( int castKind, Type type ) {
		return type instanceof FloatType 
			|| type instanceof IntType 
			|| type instanceof CharType;
		}

	public void initAddress( RunEnv runEnv, PtrValue address ) {
		address.setValue( FloatValue.defaultValue );
		}
	}
