package type.basicType;

import type.*;
import runEnv.*;
import runEnv.basicValue.*;

public  class NullType extends BasicType {

	public final static NullType type = new NullType();

	public NullType() {
		}

	public boolean equals( Type type ) {
		return type instanceof NullType;
		}

	public String toString() {
		return "NullType";
		}
		
	public void initAddress( RunEnv runEnv, PtrValue address ) {
		address.setValue( NullValue.defaultValue );
		}
	}
