package node.exprNode.binaryNode;

import node.exprNode.*;

public class ConcatNode extends BinaryNode {

	public ConcatNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_CONCAT;
		operator = "";
		}
		
	public boolean match( String s ) {
		for ( int i = 0; i < s.length() + 1; i++ )
			if ( left.match( s.substring( 0, i ) ) && right.match( s.substring( i ) ) )
				return true;
		return false;
		}
		
	}
