package node.exprNode;

import runEnv.*;

public class IdentNode extends ExprNode {

	private String ident;

	public IdentNode( String ident ) {
		this.ident = ident;
		precedence = PREC_PRIMARY;
		}

	public String toString() {
		return ident;
		}

	public int eval( RunEnv runEnv ) {
		return runEnv.get( ident );
		}
		
	}
