package node;

import node.*;
import runEnv.*;
import text.*;

import java.util.*;

public class ListNode< ElementType > extends Node {

	private Vector< ElementType > list = new Vector< ElementType >();
	private String separator;
	
	public ListNode( String separator ) {
		this.separator = separator;
		}
	
	public int size() { return list.size(); }

	public ElementType elementAt( int i ) { 
		return ( ElementType ) list.elementAt( i ); 
		}

	public void addElement( ElementType element ) {
		list.addElement( element );
		}
		
	public String toString() {
		String result = "";
		for ( int i = 0; i < size(); i++ ) {
			if ( i > 0 )
				result += separator;
			ElementType element = elementAt( i );
			result += element;
			}
		return result;
		}
		
	}

