package node.exprNode.binaryNode.relationNode;

import runEnv.*;
import node.exprNode.*;

public class LessEqualNode extends RelationNode {

	public LessEqualNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_REL;
		operator = "<=";
		}

	public Object eval( RunEnv runEnv ) {
		int leftValue = Cast.intValue( left.eval( runEnv ) );
		int rightValue = Cast.intValue( right.eval( runEnv ) );
		return new Boolean( leftValue <= rightValue );
		}
		
	}
