package node.stmtNode;

import runEnv.*;
import node.exprNode.*;

public class WhileStmtNode extends StmtNode {

	private ExprNode cond;
	private StmtNode stmt;

	public WhileStmtNode( ExprNode cond, StmtNode stmt ) {
		this.cond = cond;
		this.stmt = stmt;
		}

	public String toString() {
		return "while " + cond + " do%+%n" + stmt + "%-";
		}

	public void eval( RunEnv runEnv ) {
		while ( Cast.booleanValue( cond.eval( runEnv ) ) )
			stmt.eval( runEnv );
		}
		
	}
