package node.exprNode;

import runEnv.*;

public class VariableNode extends ExprNode {

	private String ident;
	
	public VariableNode( String ident ) {
		this.ident = ident;
		precedence = PREC_PRIMARY;
		}

	public Object eval( RunEnv runEnv ) {
		return runEnv.search( ident );
		}

	public String toString() {
		return ident;
		}
	}
