package node.exprNode.binaryNode.boolNode;

import runEnv.*;
import node.exprNode.*;

public class OrNode extends BoolNode {

	public OrNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_OR;
		operator = "or";
		}

	public Object eval( RunEnv runEnv ) {
		boolean leftValue = Cast.booleanValue( left.eval( runEnv ) );
		boolean rightValue = Cast.booleanValue( right.eval( runEnv ) );
		return new Boolean( leftValue || rightValue );
		}
		
	}
