package node.stmtNode;

import runEnv.*;
import node.exprNode.*;
import text.*;

import java.util.*;

public class PrintStmtNode extends StmtNode {

	private ExprListNode exprList;
	
	public PrintStmtNode( ExprListNode exprList ) {
		this.exprList = exprList;
		}
		
	public String toString() {
		return "print " + exprList + ";";
		}
		
	public void eval( RunEnv runEnv ) {
		Vector result = exprList.eval( runEnv );
		for ( int i = 0; i < result.size(); i++ )
			Print.interp().print( result.elementAt( i ) );
		Print.interp().println();
		}

	}
