package runEnv;

import node.stmtNode.*;
import node.exprNode.*;

public class FunctionValue {

	private FormalParamListNode formalParamList;
	private ExprNode expr;
	private RunEnv globals;

	public FormalParamListNode formalParamList() { return formalParamList; }
	public ExprNode expr() { return expr; }
	public RunEnv globals() { return globals; }

	public FunctionValue( 
		FormalParamListNode formalParamList, 
		ExprNode expr, 
		RunEnv globals ) {

		this.formalParamList = formalParamList;
		this.expr = expr;
		this.globals = globals;
		}

	public String toString() {
		return "( " + formalParamList + " ) = " + expr;
		}

	}
