package node.exprNode;
import runEnv.*;
import node.*;

import java.util.*;

public class ExprListNode extends ListNode< ExprNode > {

	public ExprListNode() {
		super( ", " );
		}
	
	public ExprListNode( ExprNode node ) {
		this();
		addElement( node );
		}
		
	public Vector< Object > eval( RunEnv runEnv ) {
		Vector< Object > result = new Vector< Object >();
		for ( int i = 0; i < size(); i++ ) {
			ExprNode expr = ( ExprNode ) elementAt( i );
			result.addElement( expr.eval( runEnv ) );
			}
		return result;
		}
		
	}
