package node.exprNode.binaryNode.arithNode;
import runEnv.*;
import node.exprNode.*;

import java.util.*;

public class TimesNode extends ArithNode {

	public TimesNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_MUL;
		operator = "*";
		}

	public Object eval( RunEnv runEnv ) {
		int leftValue = Cast.intValue( left.eval( runEnv ) );
		int rightValue = Cast.intValue( right.eval( runEnv ) );
		return new Integer( leftValue * rightValue );
		}
		
	}
