package node.exprNode.primaryNode;
import runEnv.*;
import node.exprNode.*;

import java.util.*;

public class ChrNode extends PrimaryNode {

	private ExprNode expr;
	
	public ChrNode( ExprNode expr ) {
		this.expr = expr;
		}
		
	public String toString() {
		return "chr( " + expr + " )";
		}
		
	public Object eval( RunEnv runEnv ) {
		return new Character( ( char ) Cast.intValue( expr.eval( runEnv ) ) );
		}

	}
