package node;
import env.*;
import runEnv.*;
import node.declNode.*;

public class ProgramNode extends Node {

	private BlockNode blockNode;

	public ProgramNode( BlockNode blockNode ) {
		this.blockNode = blockNode;
		}

	public String toString() {
		return "program%+%n" + blockNode + ".%-%n";
		}
		
	public void checkType() {
		Block block = new Block();
		Env env = new Env( block, null );
		blockNode.checkType( env );
		}

	public void eval() throws ReturnException {
		Multiple locals = new Multiple( 0 );
		RunEnv env = new RunEnv( locals, null );
		blockNode.eval( env );
		}
	}
