package node.exprNode.valueNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class IntValueNode extends ValueNode {

	private Integer value;

	public IntValueNode( Integer value ) {
		this.value = value;
		}

	public String toString() {
		return "" + value;
		}

	public Type checkType( Env env ) {
		type = IntType.type;
		return type;
		}
		
		
	public RunValue eval( RunEnv runEnv ) {
		return new RunValue( value.intValue() );
		}
	}
