package node.exprNode.valueNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class RealValueNode extends ValueNode {

	private Double value;

	public RealValueNode( Double value ) {
		this.value = value;
		}

	public String toString() {
		return "" + value;
		}

	public Type checkType( Env env ) {
		type = RealType.type;
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		return new RunValue( value.doubleValue() );
		}
	}
