package runEnv;

public class RunEnv {

	private Multiple locals;
	private RunEnv globals;

	public Multiple locals() { return locals; }
	public RunEnv globals() { return globals; }

	public RunEnv( Multiple locals, RunEnv globals ) {
		this.locals = locals;
		this.globals = globals;
		}
	
	public RunData getData( int levelDiff, int offset ) {
	//	Print.error().println( "getData levelDiff " + levelDiff + ", offset " + offset );
		if (levelDiff == 0 )
			return locals.getData( offset );
		else
			return globals.getData( levelDiff - 1, offset );
		}

	public RunEnv staticLink( int levelDiff ) {
	//	Print.error().println( "staticLink " + levelDiff );
		if ( levelDiff == 0 )
			return this;
		else
			return globals.staticLink( levelDiff - 1 );
		}
	}
