package type;

public  class ArrayType extends Type {

	private Type subType;
	public Type subType() { 
		if ( subType == null )
			return null;
		else
			return subType.nonRefType(); 
		}
	
	public ArrayType( Type subType ) {
		this.subType = subType;
		}
	
	public boolean equals( Type type ) {
		if ( type == null )
			return false;
		type = type.nonRefType();
		if ( this == type )
			return true;
		if ( ! ( type instanceof ArrayType ) )
			return false;
		ArrayType otherType = ( ArrayType ) type;
		return subType().equals( otherType.subType() );
		}

	public String toString() {
		return "[]" + subType;
		}
		
	}
