package node.declNode.extendsOptNode;
import node.*;
import env.*;
import type.*;
import template.*;
import runEnv.*;

public class ExtendsOpt1Node extends ExtendsOptNode {

	private String ident;
	private Env env;
	private Decl decl;

	public ExtendsOpt1Node( String ident ) {
		this.ident = ident;
		}

	public String toString() {
		return "extends " + ident;
		}

	public void genEnv( Env env ) {
		this.env = env;
		decl = env.searchEnv( ident, ClassTemplate.template, Decl.PRIVATE );
		if ( decl == null )
			error( "Undeclared Class " + ident );
		}

	public Decl decl() {
		return decl;
		}
	}
