package node.exprNode.valueNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;

public class RealValueNode extends ValueNode {

	private Double value;

	public RealValueNode( Double value ) {
		this.value = value;
		}

	public String toString() {
		return "" + value;
		}

	public Type checkType() {
		type = RealType.type;
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		return new RealValue( value.doubleValue() );
		}

	public void regCode( int freeReg, int freeTemp ) {
		loadIF( ftempReg( freeReg ), literal( value.doubleValue() ) );
		}
	}
