package node.exprNode.variableNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import runEnv.*;

public abstract class VariableNode extends Node {
	protected Type type;
	public Type type() { return type; }
	protected int weight;
	public int weight() { return weight; }

	public VariableNode() {
		}
		
	public abstract void genEnv( Env env );
	public abstract Type checkType();
	public abstract RunData eval( RunEnv runEnv );
	public abstract int calcWeight();
	public abstract String addrCode( int freeReg, int freeTemp );
	}
