package node.stmtNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import runEnv.*;
import text.*;

public class Println0StmtNode extends StmtNode {

	public Println0StmtNode() {
		}
		
	public String toString() {
		return "println();";
		}
		
	public void genEnv( Env env ) {
		}

	public void checkType() {
		}

	public void eval( RunEnv runEnv ) {
		Print.interp().println();
		}

	public int calcWeight() {
		weight = MAXREG;
		return weight;
		}

	public void genCode() {
		enter();
		bsr( "IO.newline.enter" );
		exit();
		}
	}
