package node.exprNode;

public class AssignNode extends ExprNode {

	String operator;
	ExprNode left, right;

	public AssignNode( ExprNode left, ExprNode right ) {
		this.left = left;
		this.right = right;
		precedence = PREC_ASSIGN;
		operator = "=";
		}

	public String toString() {
		return 
			left.toString( PREC_ASSIGN + 1 ) 
			+ " " +  operator + " " 
			+ right.toString( PREC_ASSIGN );
		}
	}
