package node.exprNode;

import node.*;

public abstract class ExprNode extends Node {

	protected final static int PREC_ASSIGN	=	0;
	protected final static int PREC_ADD		=	1;
	protected final static int PREC_MUL		=	2;
	protected final static int PREC_PREFIX	=	3;
	protected final static int PREC_POSTFIX	=	4;
	protected final static int PREC_PRIMARY	=	5;

	protected int precedence;

	public String toString( int parentPrec ) {
		if ( precedence < parentPrec )
			return "( " + toString() + " )";
		else
			return toString();
		}
	}
