package code;

public class SpecialReg extends IntReg {

	public final static SpecialReg instPtr = new SpecialReg( "$ip" );
	public final static SpecialReg newInstPtr = new SpecialReg( "$nip" );
	public final static SpecialReg framePtr = new SpecialReg( "$fp" );
	public final static SpecialReg retAddr = new SpecialReg( "$ra" );
	public final static SpecialReg procValue = new SpecialReg( "$pv" );
	public final static SpecialReg assemTemp = new SpecialReg( "$at" );
	public final static SpecialReg globPtr = new SpecialReg( "$gp" );
	public final static SpecialReg stackPtr = new SpecialReg( "$sp" );
	public final static SpecialReg zero = new SpecialReg( "$zero" );
	public final static SpecialReg s0 = new SpecialReg( "$s0" );
	
	private String name;
	
	public SpecialReg( String name ) {
		this.name = name;
		}
	
	public String toString() {
		return name;
		}
	}
