package node.exprNode.primaryNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import code.*;

public class ThisNode extends PrimaryNode {

	public ThisNode() {
		}

	public String toString() {
		return "this";
		}

	public Type checkType() {
		type = new PtrType( env().classDecl().type().instanceType() );
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		return runEnv.instance();
		}

	public void evalCode( Node sibling ) {
		setSibling( sibling );
		setAddress( SpecialReg.instPtr );
		}
	}
