package node.stmtNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import runEnv.*;
import code.*;

public class NullStmtNode extends StmtNode {

	public NullStmtNode() {
		}
		
	public String toString() {
		return ";";
		}
		
	public void genEnv( int section, Env env ) {
		super.genEnv( section, env );
		}

	public void checkType() {
		}

	public void eval( RunEnv runEnv ) {
		}

	public void genCode() {
		}
	}
