#! /bin/bash

ulimit -t 10 -f 10240
DIR="$1"
shift
if [ "$DIR" == "" ]
then
	echo "Missing argument to run.bash"
	exit 1
fi
NATIVEDIR=`toNative.bash "$DIR"`

CCUPJAR=`toNative.bash "$LIB330/java_cup_runtime.jar"`

java -classpath "run.jar$CPSEP$CCUPJAR" Main -dir "$NATIVEDIR" "$@"
