package node.exprNode.binaryNode;

import runEnv.*;
import node.exprNode.*;

public class PlusNode extends BinaryNode {

	public PlusNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_ADD;
		operator = "+";
		}

	public int eval( RunEnv runEnv ) {
		int leftValue = left.eval( runEnv );
		int rightValue = right.eval( runEnv );
		return leftValue + rightValue;
		}
		
	}
