package node.exprNode.prefixNode;

import runEnv.*;
import node.exprNode.*;

public class NegateNode extends PrefixNode {

	public NegateNode( ExprNode right ) {
		super( right );
		operator = "-";
		}

	public int eval( RunEnv runEnv ) {
		int rightValue = right.eval( runEnv );
		return - rightValue;
		}
		
	}
