package node.exprNode;

import runEnv.*;

public class IdentNode extends ExprNode {

	private String ident;

	public IdentNode( String ident ) {
		this.ident = ident;
		precedence = PREC_PRIMARY;
		}

	public String toString() {
		return ident;
		}

	public Object eval( RunEnv runEnv ) {
		return new Integer( runEnv.get( ident ) );
		}
		
	}
