package node.exprNode.binaryNode.arithNode;

import runEnv.*;
import node.exprNode.*;

public class PlusNode extends ArithNode {

	public PlusNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_ADD;
		operator = "+";
		}

	public Object eval( RunEnv runEnv ) {
		int leftValue = Cast.intValue( left.eval( runEnv ) );
		int rightValue = Cast.intValue( right.eval( runEnv ) );
		return new Integer( leftValue + rightValue );
		}
		
	}
