package node.exprNode.binaryNode.boolNode;

import runEnv.*;
import node.exprNode.*;

public class AndNode extends BoolNode {

	public AndNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_AND;
		operator = "and";
		}

	public Object eval( RunEnv runEnv ) {
		boolean leftValue = Cast.booleanValue( left.eval( runEnv ) );
		boolean rightValue = Cast.booleanValue( right.eval( runEnv ) );
		return new Boolean( leftValue && rightValue );
		}
		
	}
