package node.exprNode.binaryNode.relationNode;

import runEnv.*;
import node.exprNode.*;

public class LessThanNode extends RelationNode {

	public LessThanNode( ExprNode left, ExprNode right ) {
		super( left, right );
		operator = "<";
		}

	public Object eval( RunEnv runEnv ) {
		int leftValue = Cast.intValue( left.eval( runEnv ) );
		int rightValue = Cast.intValue( right.eval( runEnv ) );
		return new Boolean( leftValue < rightValue );
		}
		
	}
