package node.exprNode.prefixNode;

import runEnv.*;
import node.exprNode.*;

public class NegateNode extends PrefixNode {

	public NegateNode( ExprNode right ) {
		super( right );
		operator = "-";
		}

	public Object eval( RunEnv runEnv ) {
		int rightValue = Cast.intValue( right.eval( runEnv ) );
		return new Integer( - rightValue );
		}
		
	}
