package node.declNode;
import runEnv.*;
import node.declNode.declaratorNode.*;

import java.util.*;

public class NonEmptyDeclNode extends DeclNode {

	private DeclaratorListNode declaratorList;
	public DeclaratorListNode declaratorList() { return declaratorList; }

	public NonEmptyDeclNode( DeclaratorListNode declaratorList ) {
		this.declaratorList = declaratorList;
		}

	public String toString() {
		return "%nvar%+%n" + declaratorList +";%-";
		}

	public void eval( Hashtable< String, Object > localDecls, RunEnv runEnv ) {
		declaratorList.eval( localDecls, runEnv );
		}
	}
