package node.declNode.declaratorNode;
import runEnv.*;
import node.*;

import java.util.*;

public class DeclaratorListNode extends ListNode< DeclaratorNode > {

	public DeclaratorListNode() {
		super( ",%n" );
		}
	
	public DeclaratorListNode( DeclaratorNode node ) {
		this();
		addElement( node );
		}
		
	public void eval( Hashtable< String, Object > localDecls, RunEnv runEnv ) {
		for ( int i = 0; i < size(); i++ ) {
			DeclaratorNode declarator = elementAt( i );
			declarator.eval( localDecls, runEnv );
			}
		}
	}
