package node.exprNode.binaryNode.relationNode;
import runEnv.*;
import node.exprNode.*;

import java.util.*;

public class GreaterEqualNode extends RelationNode {

	public GreaterEqualNode( ExprNode left, ExprNode right ) {
		super( left, right );
		precedence = PREC_REL;
		operator = ">=";
		}

	public Object eval( RunEnv runEnv ) {
		int leftValue = Cast.intValue( left.eval( runEnv ) );
		int rightValue = Cast.intValue( right.eval( runEnv ) );
		return new Boolean( leftValue >= rightValue );
		}
		
	}
