package node.exprNode.primaryNode;
import runEnv.*;
import node.exprNode.*;

import java.util.*;

public class InitArrayNode extends PrimaryNode {

	private ExprListNode exprList;

	public InitArrayNode( ExprListNode exprList ) {
		this.exprList = exprList;
		}

	public Object eval( RunEnv runEnv ) {
		return exprList.eval( runEnv );
		}
		
	public String toString() {
		if ( exprList.size() == 0 )
			return "{}";
		else
			return "{ " + exprList + " }";
		}
	}
