package node.exprNode.variableNode;
import runEnv.*;

import java.util.*;

public class IdentVariableNode extends VariableNode {

	private String ident;
	
	public IdentVariableNode( String ident ) {
		this.ident = ident;
		}

	public VariableValue eval( RunEnv runEnv ) {
		Hashtable< String, Object > locals = runEnv.locals( ident );
		if ( locals == null )
			error( "Undeclared Identifier " + ident );
		return new IdentVariableValue( runEnv.locals( ident ), ident );
		}

	public String toString() {
		return ident;
		}
	}
