package node.stmtNode;

import runEnv.*;
import node.exprNode.*;

public class ReturnExprStmtNode extends StmtNode {

	private ExprNode expr;

	public ReturnExprStmtNode( ExprNode expr ) {
		this.expr = expr;
		}

	public String toString() {
		return "return " + expr +";";
		}

	public void eval( RunEnv runEnv ) throws ReturnException {
		throw new ReturnException( expr.eval( runEnv ) );
		}
		
	}
