package node.exprNode.valueNode;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import text.*;

public class StringValueNode extends ValueNode {

	private String value;

	public StringValueNode( String value ) {
		this.value = value;
		}

	public String toString() {
		return "\"" + Convert.toString( value )+ "\"";
		}

	public Type checkType( Env env ) {
		type = StringType.type;
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		return new RunValue( value );
		}
	}
