package node.typeNode;
import env.*;
import type.*;
import runEnv.*;

public class ArrayTypeNode extends TypeNode {

	private TypeNode subType;

	public ArrayTypeNode( TypeNode subType ) {
		this.subType = subType;
		}

	public String toString() {
		return "[]" + subType;
		}

	public Type getType( Env env ) {
		return new ArrayType( subType.getType( env ) );
		}
		
	}
