package node;

import env.*;

public abstract class Node {

	public void error( String s ) throws Error {
		throw new Error( "Error: " + s + " at%+%n" + this + "%-" );
		}

	public abstract String toString();

	private Env env;
	
	public void genEnv( Env env ) {
		this.env = env;
		}
	
	public final Env env() { return env; }
	
	}
