package runEnv.basicValue;

import runEnv.*;

public class StringValue extends ArrayValue {

	public StringValue( Multiple base, int offset, int size ) {
		super( base, offset, size );
		}

	public StringValue( Multiple base ) {
		super( base );
		}

	public StringValue( String value ) {
		super( new Multiple( value.length() ) );
		for ( int i = 0; i < value.length(); i++ )
			base().setValue( i, new CharValue( value.charAt( i ) ) );
		}

	public String toString() {
		String result = "";
		for ( int i = 0; i < size(); i++ )
			result += getValue( i );
		return result;
		}

	public ArrayValue subArray( int start, int size ) {
		return new StringValue( base(), offset() + start, size );
		}

	}
