package type.basicType;

import type.*;
import runEnv.*;
import runEnv.basicValue.*;

public  class BoolType extends BasicType {

	public final static BoolType type = new BoolType();

	public BoolType() {
		}
	
	public boolean equals( Type type ) {
		if ( type == null )
			throw new Error( "Trying to compare null type with " + this );
		if ( type == this )
			return true;
		return type instanceof BoolType;
		}

	public String toString() {
		return "bool";
		}
		
	public RunValue defaultValue() {
		return new BoolValue( false );
		}

	}
