package type.basicType;

import type.*;
import runEnv.basicValue.*;

public  class NullType extends BasicType {

	public final static NullType type = new NullType();

	public NullType() {
		}

	public boolean equals( Type type ) {
		if ( type == null )
			throw new Error( "Trying to compare null type with " + this );
		if ( type == this )
			return true;
		return type instanceof NullType;
		}

	public String toString() {
		return "null";
		}
		
	}
