package node.exprNode.methodNameNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import runEnv.*;

public abstract class MethodNameNode extends Node {
	protected Decl decl;
	protected MethodType type;
	protected int weight;
	public Decl decl() { return decl; }
	public Type type() { return type; }
	public int weight() { return weight; }

	public abstract void genEnv( Env env );
	public abstract MethodType checkType( TypeList typeList );
	public abstract MethodValue eval( RunEnv runEnv );
	public abstract int calcWeight();
	public abstract void regCode( int freeReg, int freeTemp );
	}
