package node.exprNode.primaryNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;

public class ThisNode extends PrimaryNode {

	private Env env;

	public ThisNode() {
		}

	public String toString() {
		return "this";
		}

	public void genEnv( Env env ) {
		this.env = env;
		}

	public Type checkType() {
		type = env.classDecl().type().instanceType();
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		return runEnv.currentInstance();
		}

	public int calcWeight() {
		weight = 1;
		return weight;
		}

	public void regCode( int freeReg, int freeTemp ) {
		move( "$ip", tempReg( freeReg ) );
		}
	}
