package node.exprNode.valueNode;
import node.*;
import node.exprNode.*;
import env.*;
import type.*;
import type.basicType.*;
import runEnv.*;
import runEnv.basicValue.*;

public class BoolValueNode extends ValueNode {

	private Boolean value;

	public BoolValueNode( Boolean value ) {
		this.value = value;
		}

	public String toString() {
		return "" + value;
		}

	public Type checkType() {
		type = BoolType.type;
		return type;
		}
		
	public RunValue eval( RunEnv runEnv ) {
		return new BoolValue( value.booleanValue() );
		}

	public void regCode( int freeReg, int freeTemp ) {
		loadIQ( tempReg( freeReg ), literal( value.booleanValue() ) );
		}
	}
