package type.basicType;

import type.*;
import template.*;
import runEnv.basicValue.*;

public  class NullType extends BasicType {

	public final static NullType type = new NullType();
	public Template template() { return NullTemplate.template; }

	public NullType() {
		}

	public boolean equals( Type type ) {
		return type instanceof NullType;
		}

	public String toString() {
		return "null";
		}
		
	}
