package type.basicType;

import type.*;
import runEnv.*;
import runEnv.basicValue.*;

public  class StringType extends ArrayType {

	public final static StringType type = new StringType();

	public StringType() {
		super( CharType.type );
		}

	public boolean equals( Type type ) {
		return type instanceof StringType;
		}

	public boolean isCastable( Type type ) {
		return true;
		}

	public String toString() {
		return "string";
		}
		
	public RunValue defaultValue() {
		return new StringValue( "" );
		}

	}
